import numpy as np

def logl(x, y, sig, N):
    T1 = np.sum(y**2 / (2 * sig**2))
    T2 = np.sum(x**2 / (2 * sig**2))
    T3 = np.sum(1 / (2 * sig**2))
    T4 = np.sum(y / sig**2)
    T5 = np.sum(x * y / sig**2)
    T6 = np.sum(x / sig**2)
    delta = 4 * T2 * T3 - T6**2
    U = -T1 + (T2 * T4**2 + T3 * T5**2 - T4 * T5 * T6) / (4 * T2 * T3 - T6**2)
    log_like = (
        (1 - N / 2) * np.log(2 * np.pi)
        - np.sum(np.log(sig))
        - 1 / 2 * (np.log(delta))
        + (-T1 + (T2 * T4**2 + T3 * T5**2 - T4 * T5 * T6) / (4 * T2 * T3 - T6**2))
    )
    return log_like


def U_and_D(x, y, N):
    T1 = np.sum(y**2 / 2)
    T2 = np.sum(x**2 / 2)
    T3 = N / 2
    T4 = np.sum(y)
    T5 = np.sum(x * y)
    T6 = np.sum(x)
    D = 4 * T2 * T3 - T6**2
    U = T1 - (T2 * T4**2 + T3 * T5**2 - T4 * T5 * T6) / D
    return U, D ** (-1 / 2)
